classification
Title: [Turtle] Add clockwise and anticlockwise method as alias to right and left
Type: enhancement Stage: resolved
Components: Library (Lib) Versions: Python 3.10
process
Status: closed Resolution: rejected
Dependencies: Superseder:
Assigned To: Nosy List: eric.smith, rhettinger, serhiy.storchaka, steven.daprano, terry.reedy, zenr
Priority: normal Keywords:

Created on 2020-11-10 05:13 by zenr, last changed 2020-11-15 04:30 by zenr. This issue is now closed.

Messages (9)
msg380631 - (view) Author: Ravi Chityala (zenr) Date: 2020-11-10 05:13
The current implementation of turtle.py has right and left method for rotation.  Another approach to view rotation is either clockwise or anticlockwise. These two methods can be an alias to right and left respectively.
msg380632 - (view) Author: Raymond Hettinger (rhettinger) * (Python committer) Date: 2020-11-10 05:19
This doesn't seem useful to me.
msg380634 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2020-11-10 06:43
What other Turtle graphics implementations use commands clockwise and anticlockwise? Is it popular enough?
msg380635 - (view) Author: Steven D'Aprano (steven.daprano) * (Python committer) Date: 2020-11-10 06:50
As a new feature, it can only go into 3.10. All other versions have reached feature-freeze and can accept no new features.

We might argue that rotations should have always been written as "anticlockwise" and "clockwise", but they are long and verbose, and in English "left" and "right" are more common. I doubt many people will prefer "anticlockwise" over "left".
msg380641 - (view) Author: Eric V. Smith (eric.smith) * (Python committer) Date: 2020-11-10 09:08
I think having two ways to do the same thing in a module targeted toward beginners would be too confusing.
msg380645 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2020-11-10 09:55
Actually there are many aliases in the turtle module following the early Logo traditions. For example rt=right. If clockwise is a new standard for this command in modern Turtle implementation, we can add yet one alias. Otherwise I agree with Raymond.
msg380648 - (view) Author: Steven D'Aprano (steven.daprano) * (Python committer) Date: 2020-11-10 10:21
On Tue, Nov 10, 2020 at 09:55:40AM +0000, Serhiy Storchaka wrote:

> If clockwise is a new 
> standard for this command in modern Turtle implementation, we can add 
> yet one alias. Otherwise I agree with Raymond.

I had a very quick look at some Logo implementations:

https://resources.terrapinlogo.com/weblogo/commands/

https://www.mit.edu/~hlb/MA562/commands.html

https://reduce-algebra.sourceforge.io/manual/manualse170.html

https://docs.racket-lang.org/logo/index.html

and even 3D Logo:

https://vrmath2.net/node/12

and I can see no sign of any other Logos allowing clockwise and 
anticlockwise as aliases. So I think it is up to Ravi Chityala to 
demonstrate that this alias is already in use in some other Logo or 
turtle graphics implementations.
msg380700 - (view) Author: Ravi Chityala (zenr) Date: 2020-11-10 19:40
Hello All

In math and physics we typically use terms clockwise and
anti-clockwise and not right and left for rotation. This change will
make it easy for kids to learn the terms that they will eventually use
in math and physics anyway.

The change I am proposing is to alias right rotation with two more
names: clockwise or cw and left rotation with two more names:
anticlockwise or acw.  Programmers who are currently using left or
right can continue to do so.

Based on the documentation supplied by Steven, I agree that everyone
programming is using right and left but it might be in the right
direction to program using clockwise and anticlockwise.

Thanks,
Ravi

On Tue, Nov 10, 2020 at 2:21 AM Steven D'Aprano <report@bugs.python.org> wrote:
>
>
> Steven D'Aprano <steve+python@pearwood.info> added the comment:
>
> On Tue, Nov 10, 2020 at 09:55:40AM +0000, Serhiy Storchaka wrote:
>
> > If clockwise is a new
> > standard for this command in modern Turtle implementation, we can add
> > yet one alias. Otherwise I agree with Raymond.
>
> I had a very quick look at some Logo implementations:
>
> https://resources.terrapinlogo.com/weblogo/commands/
>
> https://www.mit.edu/~hlb/MA562/commands.html
>
> https://reduce-algebra.sourceforge.io/manual/manualse170.html
>
> https://docs.racket-lang.org/logo/index.html
>
> and even 3D Logo:
>
> https://vrmath2.net/node/12
>
> and I can see no sign of any other Logos allowing clockwise and
> anticlockwise as aliases. So I think it is up to Ravi Chityala to
> demonstrate that this alias is already in use in some other Logo or
> turtle graphics implementations.
>
> ----------
>
> _______________________________________
> Python tracker <report@bugs.python.org>
> <https://bugs.python.org/issue42302>
> _______________________________________
msg380952 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2020-11-14 02:02
'Clockwise' and 'counterclockwise'* refer to an object either continuously spinning on an axis or possibly moving in a circle.  An object in linear motion turns right or left.  This is especially true for an organism or object with left or right sides#, and this is the model for turtle and logo.  Where relevant (such as planer maze theory), I believe same is true in math and physics.

* Counterclockwise and anticlockwise are the American and British terms respectively.  American English is the standard for Python, but using either term would confuse children barely coping with the other.  Either is a mouthful to say.

# Since people on a ship can face any which way, 'starboard' and 'port' are used to unambiguiously refer to the right and left *of the ship*.

Does anyone still object to closing this?

PS Ravi:  When responding to email, please delete the quoted text (except maybe for a line or two) as it is redundant noise when your response is posted.
History
Date User Action Args
2020-11-15 04:30:23zenrsetstatus: open -> closed
resolution: rejected
stage: resolved
2020-11-14 02:02:11terry.reedysetnosy: + terry.reedy
messages: + msg380952
2020-11-10 19:40:11zenrsetmessages: + msg380700
2020-11-10 10:21:22steven.dapranosetmessages: + msg380648
2020-11-10 09:55:40serhiy.storchakasetmessages: + msg380645
2020-11-10 09:08:06eric.smithsetnosy: + eric.smith
messages: + msg380641
2020-11-10 06:50:45steven.dapranosetnosy: + steven.daprano

messages: + msg380635
versions: - Python 3.6, Python 3.7, Python 3.8, Python 3.9
2020-11-10 06:43:49serhiy.storchakasetnosy: + serhiy.storchaka
messages: + msg380634
2020-11-10 05:19:42rhettingersetnosy: + rhettinger
messages: + msg380632
2020-11-10 05:13:01zenrcreate